<html>
  <head>
    <link rel="apple-touch-icon" sizes="57x57" href="icons/apple-icon-57x57.png">
    <link rel="apple-touch-icon" sizes="60x60" href="icons/apple-icon-60x60.png">
    <link rel="apple-touch-icon" sizes="72x72" href="icons/apple-icon-72x72.png">
    <link rel="apple-touch-icon" sizes="76x76" href="icons/apple-icon-76x76.png">
    <link rel="apple-touch-icon" sizes="114x114" href="icons/apple-icon-114x114.png">
    <link rel="apple-touch-icon" sizes="120x120" href="icons/apple-icon-120x120.png">
    <link rel="apple-touch-icon" sizes="144x144" href="icons/apple-icon-144x144.png">
    <link rel="apple-touch-icon" sizes="152x152" href="icons/apple-icon-152x152.png">
    <link rel="apple-touch-icon" sizes="180x180" href="icons/apple-icon-180x180.png">
    <link rel="icon" type="image/png" sizes="192x192"  href="icons/android-icon-192x192.png">
    <link rel="icon" type="image/png" sizes="32x32" href="icons/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="96x96" href="icons/favicon-96x96.png">
    <link rel="icon" type="image/png" sizes="16x16" href="icons/favicon-16x16.png">
    <link rel="manifest" href="manifest.json">
    <meta name="msapplication-TileColor" content="#ffffff">
    <meta name="msapplication-TileImage" content="icons/ms-icon-144x144.png">
    <meta name="theme-color" content="#ffffff">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="lib/tourit.css" />
    <script src="lib/tourit.js"></script>
    <link rel="stylesheet" href="panelle.css">
    <script src="lib/snapToLines.js"></script>
    <title>Panelle.js - free comic book layout maker</title>
  </head>
  <body>
    <div class="controls">
      <fieldset id="dragClickBehavior">
        <legend>Drag/Click Behavior</legend>
        <button id="pointerMode" 
          data-tourit="panningTooltip" 
          data-tourit-next="lineMode" 
          class="img-btn selected-mode"><img src="images/pointerIcon.svg"></button>
        <button id="lineMode" 
          data-tourit="lineModeTooltip"
          data-tourit-next="panelMode"
          class="img-btn"><img src="images/lineIcon.svg"></button>
        <button id="panelMode" 
          data-tourit="panelModeTooltip"
          data-tourit-next="snappingDistanceLabel"
        class="img-btn"><img src="images/panelIcon.svg"></button>
      </fieldset>
    </div>
    <noscript>
      This tool requires javascript, sorry!
    </noscript>
    <button id="helpMode" 
      data-tourit="helpTooltip"
      data-tourit-next="outro"
      onclick="startTour()"><span class="symbol">?</span> Help</button>
    <div class="bottom-controls">
      <div class="control-row">
        <button id="previewMode"
        data-tourit="previewTooltip"
        data-tourit-next="loadLabel"
        ><img src="images/eye.svg"> Preview</button>
        <label id="loadLabel"
        data-tourit="loadTooltip"
        data-tourit-next="helpMode"
        ><img src="images/folder-open.svg"> Open<input id="loadInput" type="file" class="upload"></label>
        <button id="backToEdit" class="hidden"><img src="images/pencil.svg"> Edit</button>
        <button id="saveBtn" class="hidden"><img src="images/floppy-disk.svg"> Save</button>
      </div>
      <div class="control-row">
        <label id="snappingDistanceLabel"
          data-tourit="snappingTooltip" 
          data-tourit-next="gridSpacingLabel"
        >Snapping Distance: <input id="snappingDistance" min="1" type="number" value="20"></label>
        <label id="gridSpacingLabel"
          data-tourit="gridSpacingTooltip"
          data-tourit-next="strokeLabel"
        >Grid Spacing: <input id="gridSpacing" type="number" min="1" value="40"></label>
        <label id="strokeLabel"
          data-tourit="strokeTooltip"
          data-tourit-next="pageWidthLabel"
        >Stroke: <input id="strokeWidth" type="number" min="0" value="2"></label>
        <label id="pageWidthLabel"
          data-tourit="pageWidthTooltip"
          data-tourit-next="pageHeightLabel"
        >Page Width:<input id="pageWidth" type="number" min="1" value="550"></label>
        <label id="pageHeightLabel"
          data-tourit="pageHeightTooltip"
          data-tourit-next="previewMode"
        >Page Height:<input id="pageHeight" type="number" min="1" value="850"></label>
      </div>
    </div>
    <template id="intro" data-tourit-next="intro2">
      <p>This tool helps you make comic book panels. Here are the basics:</p>
      <h2>1. Shaping Your Panels</h2>
      <p>After using the <img src="images/panelIcon.svg" width="20" height="20"> tool to create a panel,
      <span class="keyword">drag</span> the corners of it to shape it the way you want. The corners will snap to:</p>
      <ol>
        <li>the grid</li>
        <li>guidelines</li>
        <li>the endpoints of guidelines</li>
        <li>the points where guidelines intersect</li>
      </ol>
      <img src="images/dragSnapping.gif" style="height:92px;">
    </template>
    <template id="intro2" data-tourit-next="intro3">
      <h2>2. Managing Corners:</h2>
      <p><span class="keyword">Add</span> corners by selecting an adjacent corner and pressing Enter/Space.</p>
      <p><em>Pro-tip: you can <span class="keyword">select</span> adjacent corners using the arrow keys.</em></p>
      <p><span class="keyword">Delete</span> corners using the backspace/delete key. Deleting a triangle panel deletes the entire panel (no such thing as a panel with only 2 corners).</p>
      <img src="images/manageCorners.gif" style="height:163px;">
    </template>
    <template id="intro3" data-tourit-next="pointerMode">
      <h2>3. Images</h2>
      <p>Double-click a panel to <span class="keyword">upload</span> a picture into it.</p>
      <p>You can use <span class="keyword">zooming</span> and <span class="keyword">panning</span> to position your view, <em>and</em> you can do the same thing on an image <em>within</em> a panel.</p>
      <img src="images/loadPanZoom.gif" style="height:163px;">
      <p>But you don't <em>have to</em> upload pictures into your panels! Leave a panel blank to save it off as <span class="keyword">transparent</span>.</p>

      <p>Those are the basics. Try it out, or click next to get more details.</p>
    </template>
    </template>
    <template id="panningTooltip">
      <p>Select this to drag the canvas around. It's an infinite canvas, so don't get lost! Zooming out helps if you do. A smooth-scrolling mousewheel or trackpad works best for finer control of the zooming.</p>
      <img src="images/panning.gif" style="height:152px;">
      <p>Also use this to zoom/pan images that you upload into panels.</p>
    </template>
    <template id="lineModeTooltip">
      <p>Select this to create a new line when you click/drag on the canvas. Panel corners will snap to guide lines and their intersections.</p>
      <img src="images/createGuide.gif" style="height:163px;">
    </template>
    <template id="panelModeTooltip">
      Select this to create a new panel when you click/drag on the canvas. 
      <img src="images/createPanel.gif" style="height:163px;">
    </template>
    <template id="snappingTooltip">
      <p>This will adjust the snapping distance of panel corners, so as you're dragging corners if you get within this distance to a guideline, it'll snap to it.</p>
      <img src="images/dragSnapping.gif" style="height:92px;">
    </template>
    <template id="gridSpacingTooltip">
      <p>This will adjust the size of the grid cells.</p>
      <img src="images/gridSpacing.gif" style="height:134px;">
    </template>
    <template id="strokeTooltip">
      <p>This will adjust the stroke of the panel margins.</p>
      <img src="images/stroke.gif" style="height:129px;">
    </template>
    <template id="pageWidthTooltip">
      <p>This adjusts the width of the page.</p>
      <img src="images/pageWidth.gif" style="height:134px;">
    </template>
    <template id="pageHeightTooltip">
      <p>This adjusts the height of the page</p>
      <img src="images/pageHeight.gif" style="height:134px;">
    </template>
    <template id="helpTooltip">
      <p>You can revisit this tour anytime by clicking this Help button.</p>
    </template>
    <template id="previewTooltip">
      <p>Preview and save the page when you're finished.</p>
      <img src="images/preview.gif" style="height:149px;">
    </template>
    <template id="loadTooltip">
      <p>Not as finished as you thought you were? Use this button to load back a page you saved off previously.</p>
    </template>
    <template id="outro">
      <p>And that's about it! If you see a bug or want to help make this tool better, check out the code <a href="https://gitlab.com/andrewfulrich/panelle" target="new">here.</a></p>
      <p>If you end up using this to make something, I would love to see your work! I'm <a href="https://twitter.com/andrewulrich" target="new">@andrewulrich</a> on Twitter - feel free to reach out and share.</p>
      <p>If you enjoyed this tour and want a similar one for your own app, check out <a href="https://gitlab.com/andrewfulrich/tourit.js" target="new">tourit.js</a> which is something I made in parallel with making this app.</p>
      <p>Thanks to the <a href="https://www.gnu.org/graphics/meditate.en.html" target="gnu">Levitating, Meditating, Flute-playing Gnu</a> for participating in this tour.</p>
    </template>
    <div id="preview"></div>
    <script src="panelle.js"></script>
    <script>  
      const doTheTour=tourit('intro');
      function startTour() {
        doTheTour()
        window.localStorage.setItem('tutorialDone','true')
      }
      if(!window.localStorage.getItem('tutorialDone')) {
        startTour()
      }
      if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
        alert('This tool is not currently mobile-friendly. Please try it on a laptop or desktop for now. Sorry!')
      }

      window.addEventListener('beforeunload', (event) => {
        // Cancel the event as stated by the standard.
        event.preventDefault();
        // Older browsers supported custom message
        event.returnValue = 'You may have unsaved work, are you sure you want to navigate away?';
      });
    </script>
  </body>
</html>